Subject: Validation on persist breaks with Doctrine Lazy Loading Proxies 
Description

Hey everybody,

I am currently experiencing an error with the Validate-On-Persist:

Fatal error: Call to a member function getClassName() on a non-object in
/.../Data/Temporary/Development/Cache/Code/FLOW3_Object_Classes/TYPO3_FLOW3_Persistence_Doctrine_PersistenceManager_Original.php on line 112

anager_Original.php on line 112

The stack trace is attached.

After debugging a little deeper, it appears that this happens when a lazily-loaded entity is updated. In this case, the get_class($object)
in ReflectionService returns something like "Doctrine\....Proxies\FooBarDomainModelBar" --> and obviously our Reflection Service
cannot deal with this.

Related issues:
related to TYPO3.Flow - Bug # 31502: Validation during persistence got lost i... Resolved 2011-11-02

Associated revisions
Revision 2fdc342d - 2012-01-10 11:18 - Sebastian Kurfuerst

[BUGFIX] Make updating a Doctrine Lazy Loading Proxy work

When a Doctrine lazy loading proxy is persisted again, a fatal error is thrown
because the Reflection Service cannot handle Doctrine Proxies.

We work around this issue by asking the Doctrine Entity Manager to resolve the
class name.

A Functional Test reproducing the issue is included.

Change-Id: I2d515dd450880e2fd8a6f6fab8d31720fc57ec07
Fixes: #32830
Releases: 1.0, 1.1

Revision d7af18a9 - 2012-01-10 11:23 - Sebastian Kurfuerst

[BUGFIX] Make updating a Doctrine Lazy Loading Proxy work
When a Doctrine lazy loading proxy is persisted again, a fatal error is thrown
because the Reflection Service cannot handle Doctrine Proxies.

We work around this issue by asking the Doctrine Entity Manager to resolve the
class name.

A Functional Test reproducing the issue is included.

Change-Id: Idb1fc3b797af7ed7f3bef7e19bdb786b47733899
Fixes: #32830
Releases: 1.0, 1.1

Revision 0736b6a4 - 2012-01-30 08:18 - Sebastian Kurfuerst

[BUGFIX] Fix FLOW3 1.0 Functional Tests

I introduced an error inside the functional tests in https://review.typo3.org/#change,7715
and this followup commit fixes it.

Related: #32830
Releases: 1.0
Change-Id: I526da99a99a1c9257e30a13f909a4824b11832b3

History
#1 - 2011-12-24 15:00 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7513

#2 - 2012-01-06 15:57 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7513

#3 - 2012-01-10 11:17 - Karsten Dambekalns
- Affected Flow version changed from Git master to FLOW3 1.0.2

#4 - 2012-01-10 11:17 - Karsten Dambekalns
- Category set to Persistence
- Assigned To set to Sebastian Kurfuerst
- Target version set to 1.0.3

#5 - 2012-01-10 11:19 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7513
#6 - 2012-01-10 11:25 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.0 has been pushed to the review server.
It is available at http://review.typo3.org/7715

#7 - 2012-01-18 03:26 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2fdc342d181d816f6a6ee41b7b30500f3a8741d7.
